var Conditional, exports, _;

_ = require('lodash');

Conditional = function(conditionalObject) {
  var conditions, key, method, self, _fn;
  self = this;
  this.conditions = conditions = {};
  this.types = function() {
    return _.keys(this.conditions);
  };
  this.add = function(name, func) {
    if (typeof name !== "string") {
      throw new Error("name is missing");
    }
    if (typeof func !== "function") {
      throw new Error("function is missing");
    }
    if (conditions[name]) {
      throw new Error("condition already exist: " + name);
    }
    return conditions[name] = func;
  };
  _fn = function(key, method) {
    return self.add(key, method);
  };
  for (key in conditionalObject) {
    method = conditionalObject[key];
    _fn(key, method);
  }
  return this;
};

exports = module.exports = Conditional;
