var Conditional, RouteController, exports, express, vhost, _;

Conditional = require('./helpers/conditional');

_ = require('lodash');

vhost = require('vhost');

express = require('express');

RouteController = function(key, routePath, response, options, config) {
  var validDomain, _base;
  this.key = key;
  this.routePath = routePath;
  this.response = response;
  this.options = options;
  this.config = config != null ? config : {};
  this["default"] = {
    conditions: null,
    condition: null
  };
  this.debug = this.config.debug || false;
  validDomain = /^(?!:\/\/)([a-zA-Z0-9\*]+\.)?[a-zA-Z0-9][a-zA-Z0-9-]+\.[a-zA-Z]{2,6}?$/i.exec(this.config.baseHost);
  if (this.config.baseHost && (validDomain != null ? validDomain.length : void 0)) {
    if ((_base = this.config).server == null) {
      _base.server = express();
    }
    this.vHost = vhost(this.config.baseHost, this.config.server);
  }
  if (this.response.conditions) {
    this.conditional = new Conditional(this.response.conditions);
    this.condition = function(name) {
      var tmpCondition, _ref, _ref1;
      tmpCondition = (_ref = this.conditional) != null ? (_ref1 = _ref.conditions) != null ? _ref1[name] : void 0 : void 0;
      if (!tmpCondition) {
        throw new Error("conditional method " + name + " not found");
      }
      return tmpCondition;
    };
  }
  return this;
};

RouteController.prototype.getConfig = function() {
  return _.assign(this["default"], {
    conditional: this.conditional,
    condition: this.condition,
    express: this.config.express
  });
};

RouteController.prototype.addMethod = function(name, method) {
  return this["default"][name] = method;
};

RouteController.prototype.virtualhost = function(expressInstance) {
  if (this.vHost) {
    expressInstance.use(this.vHost);
    return this.config.server;
  } else {
    return expressInstance;
  }
};

exports = module.exports = RouteController;
