var DEBUG, RouteHandler, connectMultiparty, crypto, exports, multipart, userHashKey, _;

_ = require('lodash');

connectMultiparty = require('connect-multiparty');

crypto = require('crypto');

multipart = connectMultiparty();

DEBUG = false;

userHashKey = function() {
  var ip;
  ip = this.ip || this.socket.remoteAddress;
  return new crypto.Hash('md5').update("" + ip + "::" + this.url + "::" + this.headers['user-agent']).digest('hex');
};

RouteHandler = function(controller) {
  var expressRouteArgs, response, vHost;
  response = controller.response;
  if (controller.debug) {
    console.log(controller.key, [controller.routePath]);
  }
  expressRouteArgs = [controller.routePath];
  if (_.isFunction(response != null ? response.before : void 0)) {
    expressRouteArgs.push(response.before);
  }
  expressRouteArgs.push(function(req, res, next) {
    var args, config;
    userHashKey = userHashKey.bind(req);
    controller.addMethod('userHashKey', userHashKey);
    config = controller.getConfig();
    args = [req, res, next, config];
    return response.apply(this, args);
  });
  vHost = controller.virtualhost(this);
  return vHost[controller.key].apply(vHost, _.flatten(expressRouteArgs));
};

exports = module.exports = RouteHandler;
