var exports, fs, path, walk, _;

walk = require('walkdir');

fs = require('fs');

_ = require('lodash');

path = require('path');

exports = module.exports = function(dir, routeMapper, options) {
  var base;
  base = '';
  if (fs.existsSync(dir)) {
    dir = path.normalize(dir);
    return walk.sync(dir, function(filePath, stat) {
      var Controller, basePath, controller, dirIndex, index, model;
      index = filePath.split('/');
      if (!~_.last(index).indexOf('index') === false) {
        basePath = (filePath != null ? typeof filePath.replace === "function" ? filePath.replace(dir, '') : void 0 : void 0) || '';
        basePath = basePath != null ? basePath.toString() : void 0;
        basePath = basePath.slice(0, basePath.lastIndexOf('/'));
        if (basePath.length > 1 && basePath.slice(-1) === '/') {
          basePath = base.slice(0, basePath.length - 1);
        }
        dirIndex = Number(index.length) - 1;
        Controller = require(index.splice(0, dirIndex).join('/'));
        if (_.isObject(Controller) && _.isFunction(Controller)) {
          controller = new Controller(options);
          controller.debug = options.debug || false;
          controller.host = options.host || null;
          controller.base = basePath;
          model = controller.module();
          if (controller.debug) {
            console.log({
              controller: controller,
              options: options,
              base: basePath,
              model: model
            });
          }
          return routeMapper(model);
        }
      }
    });
  } else {
    return console.log((function() {
      throw new Error("filePath does not exist " + dir);
    })());
  }
};
