#==============================================================================
# Deps
#==============================================================================
_ = require 'lodash'

Conditional = (conditionalObject) ->
  self = this
  @conditions = conditions = {}

  @types = ->
    _.keys @conditions

  @add = (name, func) ->
    if typeof name isnt "string"
      throw new Error("name is missing")

    if typeof func isnt "function"
      throw new Error("function is missing")

    if conditions[name]
      throw new Error("condition already exist: #{name}")

    conditions[name] = func

  for key, method of conditionalObject
    do (key, method) ->
      self.add key, method

  return this

exports = module.exports = Conditional


