Conditional = require './helpers/conditional'
_ = require 'lodash'
vhost = require('vhost')
express = require('express')

RouteController = (@key, @routePath, @response, @options, @config = {}) ->
  @default =
    conditions: null
    condition: null

  @debug = @config.debug or false

  #validate domain
  validDomain = /^(?!:\/\/)([a-zA-Z0-9\*]+\.)?[a-zA-Z0-9][a-zA-Z0-9-]+\.[a-zA-Z]{2,6}?$/i.exec @config.baseHost

  #validate virtualhost
  if @config.baseHost and validDomain?.length
    @config.server ?= express()
    @vHost = vhost @config.baseHost, @config.server

  if @response.conditions
    @conditional = new Conditional @response.conditions
    @condition = (name) ->
      tmpCondition = @conditional?.conditions?[name]
      unless tmpCondition
        return throw new Error "conditional method #{name} not found"
      tmpCondition

  return this

RouteController::getConfig = ->
  _.assign @default, {
    conditional: @conditional
    condition: @condition
    express: @config.express
  }

RouteController::addMethod = (name, method) ->
  @default[name] = method

RouteController::virtualhost = (expressInstance) ->
  if @vHost
    expressInstance.use @vHost
    return @config.server
  else
    return expressInstance


exports = module.exports = RouteController
