#==============================================================================
# Deps
#==============================================================================
_ = require 'lodash'
connectMultiparty = require 'connect-multiparty'
crypto = require('crypto')

#==============================================================================
# setting
#==============================================================================
multipart = connectMultiparty()
DEBUG = false

userHashKey = ->
  ip = @ip || @socket.remoteAddress
  new crypto.Hash('md5')
    .update("#{ip}::#{@url}::#{@headers['user-agent']}").digest('hex')

#==============================================================================
# RouteHandler
#==============================================================================
RouteHandler = (controller) ->
  response = controller.response

  if controller.debug
    console.log controller.key, [controller.routePath]

  #express route arguments
  expressRouteArgs = [controller.routePath]

  if _.isFunction response?.before
    expressRouteArgs.push response.before

  #route pre loader
  expressRouteArgs.push (req, res, next) ->
    #settings
    userHashKey = userHashKey.bind req
    controller.addMethod 'userHashKey', userHashKey
    config = controller.getConfig()

    #if route.fn.conditions
    args = [req, res, next, config]
    response.apply this, args

  #route setup
  vHost = controller.virtualhost this
  vHost[controller.key].apply vHost, _.flatten(expressRouteArgs)

exports = module.exports = RouteHandler
