express = require "express"
serveStatic = require('serve-static')
methodOverride = require('method-override')
bodyParser = require('body-parser')
multer = require('multer')

describe 'express http methods ::', ->
  agent = superagent.agent()
  port = 9090
  app = express()
  require("../../src/main").use app

  app.all '/params', (req, res) ->
    res.json
      params: req.body
      files: req.files
      urlParams: req.params
      query: req.query

  methods = [
    'get'
    'post'
    'put'
    'patch'
    'delete'
    'copy'
    'head'
    'options'
    'purge'
    'trace'
  ]

  before ->
    for method in methods
      app[method] '/', (req, res) ->
        res.send(req.method.toLowerCase())

  #==============================================================================
  # basic test
  #==============================================================================
  for method in methods
    it "should has #{method} route", (done) ->
      supertest(app)[method]('/').expect(200, done)

  it "should post route", (done) ->
    supertest(app)
      .post('/params')
      .set('Accept', 'application/json')
      .send({ name: 1000 })
      .expect(200)
      .end (err, res) ->
        console.log res.body
        expect(res.body.params.name).to.equal 1000
        done()

  it "should post route", (done) ->
    supertest(app)
      .post('/params')
      .set('Accept', 'application/json')
      .attach('testing01', "#{__dirname}/../fixture/static/testing.jpg")
      .expect(200)
      .end (err, res) ->
        console.log res.body.files
        expect(res.body.files.testing01.fieldname).to.equal 'testing01'
        expect(res.body.files.testing01.mimetype).to.equal 'image/jpeg'
        expect(res.body.files.testing01.extension).to.equal 'jpg'
        expect(res.body.files.testing01.size).to.equal 5205
        done()

  it "should get route", (done) ->
    supertest(app)
      .get('/params?order=desc&shoe[color]=blue&shoe[type]=converse')
      .set('Accept', 'application/json')
      .expect(200)
      .end (err, res) ->
        expect(res.body.query.order).to.equal 'desc'
        done()



