express = require "express"
_ = require 'lodash'
app = express()
require("../../src/main").use app

describe 'mapping conditions methods ::', ->
  agent = superagent.agent()
  
  methods = [
    'get'
    'post' 
    'put'
    'patch'
    'delete'
    'copy'
    'options'
    'purge'
    'trace'
  ]

  before ->
    mapper = routes: {}

    handleRoute = (req, res, next, config) ->
      res.config = config
      config.condition('limitAccessToLocalHost')
      res.json
        types: config.conditional.types()
        hash: config.userHashKey()
        domainName: config.condition('domainName')

    handleRoute.conditions =
      limitAccessToLocalHost: ->
      domainName: ->

    app.routeMapper
      routes:
        '/mapping-conditions-methods':
          'get': handleRoute
          'post': handleRoute
          'put': handleRoute
          'patch': handleRoute
          'delete': handleRoute
          'copy': handleRoute
          'head': handleRoute
          'options': handleRoute
          'purge': handleRoute
          'trace': handleRoute
          
  #==============================================================================
  # basic test
  #==============================================================================
  for method in methods
    do (method) =>
      it "should has #{method} route", (done) ->
        supertest(app)[method]('/mapping-conditions-methods')
          .set('Accept', 'application/json')
          .expect(200)
          .end (err, res) ->
            if err then return done err
            index = _.indexOf res.body.types, 'limitAccessToLocalHost'
            expect(index).to.be.at.least 0
            expect(res.body.hash.length).to.be.at.least 30

            done()


    it "should has head route", (done) ->
      supertest(app)['head']('/mapping-conditions-methods')
        .set('Accept', 'application/json')
        .expect(200)
        .end (err, res) ->
          if err then return done err
          index = _.indexOf res.body.types, 'limitAccessToLocalHost'
          expect(index).to.be.below 0
          done()
