express = require "express"
_ = require 'lodash'
app = express()
require("../../src/main").use app

describe 'mapping conditions methods ::', ->
  agent = superagent.agent()
  
  methods = [
    'get'
    'post' 
    'put'
    'patch'
    'delete'
    'copy'
    'options'
    'purge'
    'trace'
  ]

  before ->
    mapper = routes: {}

    handleRoute = (req, res, next, config) ->
      res.json
        types: config.conditional.types()

    handleRoute.conditions =
      domainName: ->
      isUserLogin: -> false

    userIsLoginRoute = (req, res, next, config) ->
      res.json
        login: config.condition('isUserLogin')()

    userIsLoginRoute.conditions =
      isUserLogin: -> true

    app.routeMapper
      routes:
        '/mapping-conditions-methods':
          'get': handleRoute
          'post': handleRoute
          'put': handleRoute
          'patch': handleRoute
          'delete': handleRoute
          'copy': handleRoute
          'head': handleRoute
          'options': handleRoute
          'purge': handleRoute
          'trace': handleRoute
          
          '/user-not-login':
            'get': (req, res, next, config) ->
              res.json
                login: config.condition('isUserLogin')()
            '/status':
              'get': (req, res, next, config) ->
                res.json
                  login: config.condition('isUserLogin')()

          '/user-is-login':
            'get': userIsLoginRoute
            '/status':
              'get': (req, res, next, config) ->
                res.json
                  login: config.condition('isUserLogin')()

  #==============================================================================
  # basic test
  #==============================================================================
  for method in methods
    do (method) =>
      it "should has #{method} route", (done) ->
        supertest(app)[method]('/mapping-conditions-methods')
          .set('Accept', 'application/json')
          .expect(200)
          .end (err, res) ->
            if err then return done err
            index = _.indexOf res.body.types, 'domainName'
            expect(index).to.be.at.least 0
            done()


    it "should has head route", (done) ->
      supertest(app)['head']('/mapping-conditions-methods')
        .set('Accept', 'application/json')
        .expect(200)
        .end (err, res) ->
          if err then return done err
          index = _.indexOf res.body.types, 'domainName'
          expect(index).to.be.below 0
          done()

    describe 'user >>', ->
      it "should  not be login", (done) ->
        supertest(app)['get']('/mapping-conditions-methods/user-not-login')
          .set('Accept', 'application/json')
          .expect(200)
          .end (err, res) ->
            if err then return done err
            expect(res.body.login).to.equal false
            done()

    describe 'user >>', ->
      it "should  not be login", (done) ->
        supertest(app)['get']('/mapping-conditions-methods/user-is-login')
          .set('Accept', 'application/json')
          .expect(200)
          .end (err, res) ->
            if err then return done err
            expect(res.body.login).to.equal true
            done()

    describe 'user >>', ->
      it "should  not be login", (done) ->
        supertest(app)['get']('/mapping-conditions-methods/user-is-login/status')
          .set('Accept', 'application/json')
          .expect(200)
          .end (err, res) ->
            if err then return done err
            expect(res.body.login).to.equal true
            done()

    describe 'user >>', ->
      it "should  not be login", (done) ->
        supertest(app)['get']('/mapping-conditions-methods/user-not-login/status')
          .set('Accept', 'application/json')
          .expect(200)
          .end (err, res) ->
            if err then return done err
            expect(res.body.login).to.equal false
            done()