express = require "express"
_ = require 'lodash'


describe 'Virtual Host ::', ->
  agent = superagent.agent()
  app = null
  app = express()
  require("../../src/main").use app
  myDomainServer = express()

  methods = [
    'get'
    'post'
    'put'
    'patch'
    'delete'
    'copy'
    'options'
    'purge'
    'trace'
  ]

  before ->
    myDomainServer.get '/route', (req, res) ->
      res.send('one.lvh.me/route')

    app.routeMapper
      host: 'one.lvh.me'
      server: myDomainServer
      base: '/'
      routes:
        'get': (req, res) ->
          res.send('one.lvh.me/')

    app.routeMapper
      host: 'two.lvh.me'
      base: '/'
      routes:
        'get': (req, res) ->
          res.send('two.lvh.me/')

    mapper =
      host: 'three.lvh.me'
      base: '/hello-world'
      mvc: "#{__dirname}/../fixture/mvc/"
      routes:
        'get': (req, res) ->
          res.send('one.lvh.me/')

    app.routeMapper(mapper)

  #==============================================================================
  # basic test
  #==============================================================================
  it "should has http://one.lvh.me:9145/", (done) ->
    server = app.listen 9145, ->
      request.get 'http://one.lvh.me:9145', (error, response, body) ->
        expect(body).to.equal 'one.lvh.me/'
        server.close()
        done()

  it "should has http://one.lvh.me:9145/route", (done) ->
    server = app.listen 9145, ->
      request.get 'http://one.lvh.me:9145/route', (error, response, body) ->
        expect(body).to.equal 'one.lvh.me/route'
        server.close()
        done()

  it "should has http://two.lvh.me:9145/", (done) ->
    server = app.listen 9145, ->
      request.get 'http://two.lvh.me:9145/', (error, response, body) ->
        expect(body).to.equal 'two.lvh.me/'
        server.close()
        done()

  it "should has http://three.lvh.me:9145/", (done) ->
    server = app.listen 9145, ->
      request.get 'http://three.lvh.me:9145/api/user/location/city/', (error, response, body) ->
        expect(body).to.equal 'CityNy'
        server.close()
        done()








